
$(document).on("click", "#selected-com", slectedCom);
$(document).on("change", "#com-port", clearSelect);

function convertArrayBufferToString(buf) {
	var bufView = new Uint8Array(buf);
	var encodedString = String.fromCharCode.apply(null, bufView);
	return decodeURIComponent(encodedString);
}

var DEVICE_PATH = null;
var devicePathOld = null;

chrome.serial.getDevices(onGetDevices);// get all available to use com port 

// function callback for get com ports and filling selector data that got
function onGetDevices(ports) {
	var $comPortSelect = $("#com-port");
	$comPortSelect.empty();
	let hasPorts = [];
	for (var i = 0; i < ports.length; i++) {
		hasPorts[i] = ports[i].path;
		console.log(hasPorts[i]);
		$comPortSelect.append(`<option value="${hasPorts[i]}">${hasPorts[i]}</option>`);
	}
}

// when user select com port we try connect to this port 
function slectedCom() {
	var $comPortSelect = $("#com-port");
	var comNum = $("option:selected", $comPortSelect).val();
	devicePathOld = DEVICE_PATH;

	DEVICE_PATH = comNum;
	//check conection, if we have some connect then disconnect and free COMport
	chrome.serial.getConnections(function (_arrConnectionInfo) {
		if (devicePathOld != DEVICE_PATH) {

			$(this).prop("disabled", true);

			if (_arrConnectionInfo.length == 0) {
				console.log("We don't have any connection");
				chrome.serial.connect(DEVICE_PATH, onConnect);
			} else {
				let idConnection = parseInt(_arrConnectionInfo[0].connectionId);

				chrome.serial.disconnect(idConnection, function () {
					console.log("Disconnet COM");
					chrome.serial.connect(DEVICE_PATH, onConnect);
				});
			}
		}
	});
}

function clearSelect() {
	$("#com-port").removeClass("is-valid is-invalid");
	$("#connected-device").text("").removeClass("valid-feedback invalid-feedback");
}

function onConnect(connectionInfo) {
	if (connectionInfo == null) {
		DEVICE_PATH = "";
		$("#com-port").removeClass("is-valid").addClass("is-invalid");
		$("#connected-device").text("No connection").removeClass("valid-feedback").addClass("invalid-feedback");

	} else {
		connectionId = connectionInfo.connectionId;
		$("#com-port").addClass("is-valid").removeClass("is-invalid");
		$("#connected-device").text("Connected").addClass("valid-feedback").removeClass("invalid-feedback");

	}

	$("#selected-com").prop("disabled", false);
}



var str = "";
var idExtesion = "aklckjhpnhjlokmiabopgegdgedelpjg";

var onReceiveCallback = function (info) {
	let tmp = convertArrayBufferToString(info.data);
	console.log("get data =  " + JSON.stringify(tmp));

	if (tmp.includes("\r\n")) {

		str += tmp.substr(0, tmp.indexOf("\r\n"));
		console.log('received: ', str);

		if (!str.includes('No') && str != "") {
			let numberCard = "";
			let position = str.indexOf(",");

			for (let i = position - 3; i <= position + 5; i++) {
				numberCard += str[i];
			}

			console.log("we have number card");
			console.log(numberCard);
			chrome.runtime.sendMessage(idExtesion, numberCard, (response) => {
				console.log(response);
			});
		};

		if (tmp.indexOf("\r\n") < tmp.length - 2) {
			str = tmp.substr(tmp.indexOf("\r\n") + 2);
		} else {
			str = "";
		}

	} else {
		str += tmp;
	}
};


chrome.serial.onReceive.addListener(onReceiveCallback);






